﻿Type=Class
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore

	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "ContPage"
		
	Private qsd, qed As Long
	
	Private Page_name As String = ""

	Private ABMPageId As String = ""

	Dim cnt1 As ABMContainer
	

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!

	BuildPage
	
	
End Sub


Sub InitPublicVars
	
	DateTime.DateFormat = "yyyy-MM-dd"

	qsd = DateTime.Now - (DateTime.TicksPerDay * 10)
	qsd = DateTime.DateParse(DateTime.Date(qsd)) 
	
	qed = DateTime.Now
	
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("  ----"&Name&" view ws Connected")
	
	ws = WebSocket1
	ABMPageId = ABM.GetPageID( page,  Name, ws)
	Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds)
	If session.IsNew Then
		session.Invalidate
		ABMShared.NavigateToPage(ws, "", "./")
		Return
	End If

	ABMShared.NeedsAuthorization = True
	
	If ABMShared.NeedsAuthorization Then
		If session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, ABMPageId, "../")
			Return
		End If
	End If
	
	ABM.UpdateFromCache(Me, ABMShared.CachedPages, ABMPageId, ws)
	If page.ComesFromPageCache Then
		' refresh the page
		page.Refresh
		' because we use ShowLoaderType=ABM.LOADER_TYPE_MANUAL
		page.FinishedLoading
	Else
		If page.WebsocketReconnected Then
			Log("Websocket reconnected")
			' when we have a client that doesn't have the page in cache and it's websocket reconnected and also it's session is new - basically when the client
			' had internet problems and it's session (and also cache) expired before he reconnected so the user has content in the browser but we don't have
			' any on the server. So we need to reload the page.
			' when a client that doesn't have the page in cache and it's websocket reconnected but it's session is not new - when the client had internet
			' problems and when he reconnected it's session was valid but he had no cache for this page we need to reload the page as the user browser has
			' content, reconnected but we have no content in cache
			ABMShared.NavigateToPage (ws, ABMPageId, "./" & page.PageHTMLName)
		Else
			' when the client did not reconnected it doesn't matter if the session was new or not because this is the websockets first connection so no dynamic
			' content in the browser ... we are going to serve the dynamic content...
			Log("Websocket first connection")
			page.Prepare
			ConnectPage
		End If
				
	End If

	page.RestoreNavigationBarPosition
	page.NavigationBar.Refresh

	Log(Name &ABMPageId)
End Sub



Private Sub WebSocket_Disconnected
	Log(" page Disconnected")
End Sub

Sub Page_ParseEvent(Params As Map)
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	
	' log the events and params.....
	Log(" event name and params: "&eventName&"  "&eventParams(0))
	
	If eventName.Contains("cnt1-") Then
		eventName = eventName.SubString(5)'  Replace("-","_")
	End If
	
	If eventName = "beforeunload" Then
		Log("preparing for page url refresh")
		'        ws.session.SetAttribute("ABMNewSession", True)
		ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)

		Return
	End If
	
	If SubExists(Me, eventName) Then
		Params.Remove("eventname")
		Params.Remove("eventparams")
		Select Case Params.Size
			Case 0
				CallSub(Me, eventName)
			Case 1
				CallSub2(Me, eventName, Params.Get(eventParams(0)))
			Case 2
				If Params.get(eventParams(0)) = "abmistable" Then
					Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
					CallSub2(Me, eventName, PassedTables)
				Else
					CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
				End If
			Case Else
				' cannot be called diretly, to many param
				CallSub2(Me, eventName, Params)
		End Select
	End If
End Sub



public Sub BuildPage()
	
	
	' initialize the theme
	BuildTheme
	DateTime.TimeFormat = "HH:mm"
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & ABMShared.AppName & "/" & Name, False, ABMShared.SessionMaxInactiveIntervalSeconds, theme)
	
	
	page.ShowLoader=True
	page.ShowLoaderType=ABM.LOADER_TYPE_MANUAL ' NEW
	
	
	page.PageTitle = "Test Container"
	page.PageDescription = ""
	page.PageHTMLName = "index.html"
	page.PageKeywords = "ABMaterial"
	page.PageSiteMapPriority = "0.50"
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_MONTHLY
		
	ABMShared.BuildNavigationBar(page,  Page_name, "../images/logo.png", "", "Apps", Page_name)
	
	page.AddRowsM( 1, False,  10,   3, "").AddCellsOSMP(1,0,0,0, 4,4,4, 5 , 5,  5 , 0,"cnter").AddCellsOSMP(1,0,0,0,4,4,4,5,5,30,10,"cnter").AddCellsOSMP(1,0,0,0,4,4,4,5,5,30 , 10,"cnter")
	page.AddRows(2,False, "") .AddCellsOSMP(1,0,0,0, 4,4,4,0,0 , 5,0,  "").AddCellsOSMP(1,0,0,0,8,8 ,8,0,0, 10,5,  "cnter")

	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
     
	' create a container for components...

	cnt1.Initialize(page,"cnt1","cntth")
	
	' add rows / cells to the container
	cnt1.AddRowsM(2,True, 0,  0,  "").AddCellsOS(1,0, 0,0,0, 12, 12, "")
	cnt1.AddRowsM( 1 , True,0, 0, "").AddCellsOSMP(2,0,0,0,6, 6,6, 0, 0,0,0,  "") 

	cnt1.AddRows(1 , True, "").AddCellsOSMP(2,0,0,0,6, 6,6, 0, 0,0,0,  "") 
	cnt1.AddRowsM(1,True, 0,  0,  "").AddCellsOS(1,0, 0,0,0, 12, 12, "")
	cnt1.AddRows(1 , True, "") .AddCellsOSMP(2,0,0,0,6, 6,6, 0, 0,0,0,  "") 

	cnt1.AddRowsM(1,True, 0,  0,  "").AddCellsOS(1,0, 0,0,0, 12, 12, "") 

	cnt1.AddRowsM(12,True, 0,  0,  "").AddCellsOS(1,0, 0,0,0, 12, 12, "")
	cnt1.BuildGrid' IMPORTANT
	
	
	

End Sub

Sub GetDevicehgt() As Int
	
	' get the browser height...
	
	Dim NowWH  As String = ABM.GetBrowserWidthHeight( page)
	
	If NowWH <> "" And NowWH <> ";" Then ' check if we got something useful back
		Dim split() As String = Regex.Split(";", NowWH) ' split the string
		Dim Neww As Int = split(0)
		Dim NewH As Int = split(1)
		
		Log(" Width: "&Neww& "  Height: "&NewH)
	Else
		Dim NewH As Int = -1
	End If
    
	Return NewH
	
End Sub


Sub ConnectPage()

	InitPublicVars
	
	ABMShared.ConnectNavigationBar(page)
	
	Dim scrnhgt As Int = GetDevicehgt  ' not used....
	
	Dim lblsd As ABMDateTimePicker
	lblsd.Initialize(page, "sd", ABM.DATETIMEPICKER_TYPE_DATETIME, qsd, "START:","") ' ABM.SIZE_H6,False, "")
	'lblsd.ClickThrough = True  ' turn clickthru off....
	
	' note the difference with - lbled.ClickThrough = True
	Dim lbled As ABMDateTimePicker
	lbled.Initialize(page, "ed", ABM.DATETIMEPICKER_TYPE_DATETIME, (qed), "END:","") ' ABM.SIZE_H6,False, "")
	lbled.ClickThrough = True

	
	Dim rptg As ABMLabel
	rptg.Initialize(page,"rptg","Person Group: ",ABM.SIZE_H5,False, "")

	Dim rptd As ABMLabel
	rptd.Initialize(page,"rptd","Date Range: ",ABM.SIZE_H5,False, "")

	Dim rptv As ABMLabel
	rptv.Initialize(page,"rptv","Driver: ",ABM.SIZE_H5,False, "")

	Dim rpto As ABMLabel
	rpto.Initialize(page,"rpto","Contractor: ",ABM.SIZE_H5,False, "")


	'  Use a radio button with no line break ( side by side)
	Dim rg As ABMRadioGroup
	rg.Initialize(page,"rg1","")
	rg.AddRadioButtonNoLineBreak( "Configuration"&".   .   .    .    .     .",True)
	rg.AddRadioButton("Applications",True)
    	
	
	Dim repto As ABMCombo
	Dim sql As SQL = DBM.GetSQL
	repto.Initialize(page, "repto","Select a Contractor",400, "")

	repto.AddItem(  "-1", "ALL", BuildSimpleItem(""&"0", "mdi-action-star-rate", "{NBSP}{NBSP}"&"ALL"))
	repto.AddItem(  "1", "None", BuildSimpleItem(""&"1", "mdi-action-star-rate", "{NBSP}{NBSP}"&"None"))
	repto.AddItem(  "2", "Maybe", BuildSimpleItem(""&"2", "mdi-action-star-rate", "{NBSP}{NBSP}"&"Maybe"))
	repto.AddItem(  "3", "Some", BuildSimpleItem(""&"3", "mdi-action-star-rate", "{NBSP}{NBSP}"&"Some"))
	repto.AddItem(  "4", "ALL & Then Some", BuildSimpleItem(""&"4", "mdi-action-star-rate", "{NBSP}{NBSP}"&"ALL & Then Some"))
	repto.DataBelow = ABM.COMBO_DATA_BELOWINPUT
	repto.SetActiveItemId(-1)
		
		
	Dim combdrv As ABMCombo
	Dim sql As SQL = DBM.GetSQL
	combdrv.Initialize(page, "combdrv","Select a Driver",400, "")

	combdrv.AddItem(  "-1", "ALL Drivers", BuildSimpleItem(""&"0", "mdi-action-star-rate", "{NBSP}{NBSP}"&"ALL Drivers"))
	Dim users As List = DBM.SQLSelect(sql, "SELECT * FROM users Order by UserName", Null)
	If users.Size > 0 Then
		For i = 0 To users.Size -1
			Dim user As Map = users.Get(i)
			Log(" driver map: "&user)
			Dim id As String = user.Get("userid")
			Dim val As String = user.Get("username")
			' Log(" Driver: "&val)
			combdrv.AddItem( ""& id, val, BuildSimpleItem(""&id, "mdi-action-star-rate", "{NBSP}{NBSP}"&val))
		Next
	End If
	
	DBM.CloseSQL(sql)
	combdrv.SetActiveItemId("-1")
	combdrv.Refresh



	Dim report As ABMCombo
	report.Initialize(page, "report","Select a Person",400, "")

	Dim sql As SQL = DBM.GetSQL
	Dim users As List = DBM.SQLSelect(sql, "SELECT * FROM users", Null) 
	
	If users.Size > 0 Then
		For i = 0 To users.Size -1
			Dim user As Map = users.Get(i)
			Dim id As String = user.Get("userid")
			Dim val As String = user.Get("username")
			report.AddItem(  ""&id, val, BuildSimpleItem(""&id, "mdi-action-star-rate", "{NBSP}{NBSP}"&val))
		Next
	End If
	DBM.CloseSQL(sql)
	
	'  add items to components
	
	cnt1.Cell(1,1).AddComponent( ABMShared.BuildParagraphBQWithZDepth(page ,"par1","  {NBSP}{NBSP}"&"Select Something to View") )

	cnt1.Cell(2,1).AddComponent(rptg)

	cnt1.Cell(2,1).AddComponent(report)
	cnt1.Cell(2,1).AddComponent(rg)
	rg.SetActive(1)
	
	cnt1.Cell(3,1).AddComponent(rptd)
	cnt1.Cell(4,1).AddComponent(lblsd) 
	cnt1.Cell(4,2).AddComponent(lbled) 
	
	cnt1.Cell(5,1).AddComponent(rptv)
	cnt1.Cell(6,1).AddComponent(combdrv)

	cnt1.Cell(7,1).AddComponent(rpto)
	cnt1.Cell(8,1).AddComponent(repto)

	Dim btnrun As ABMButton
	btnrun.InitializeFlat( page , "btnrun", "mdi-notification-event-available", ABM.ICONALIGN_LEFT, "SHOW Message Box","")
	btnrun.UseFullCellWidth = True
	cnt1.Cell(10,1).AddComponent(btnrun)

	Dim rptg As ABMLabel
	rptg.Initialize(page,"nbsp","{NBSP}",ABM.SIZE_H6,False, "")
	cnt1.Cell(11,1).AddComponent(rptg)
	
	
	' add the container to the page - with all the components attached
	page.Cell(2,1).AddComponent(cnt1)


	' add other items to the page
	Dim rptg1 As ABMLabel
	rptg1.Initialize(page,"imgname","Select a Person",ABM.SIZE_H3,False, "")
	page.Cell(2, 2).AddComponent(rptg1)

	Dim rptg1 As ABMLabel
	rptg1.Initialize(page,"nbsp1","{NBSP}",ABM.SIZE_H1,False, "")
	page.Cell(2,2).AddComponent(rptg1)


    Dim img As ABMImage
	img.Initialize(page,"img1","../images/batman.png",1.0)
    img.IsClickable = True 
	' add the image to the page 	
	page.Cell(2, 2).AddComponent(img)
	
	
	
	page.FinishedLoading 'IMPORTANT
	Log(" Finished loading and connecting page")
	
	page.RestoreNavigationBarPosition

	page.NavigationBar.Title = "Containers" 
	
	page.Refresh


End Sub


Sub combdrv_Clicked(Target As String)

	report_Clicked(Target)

End Sub



Sub img1_Clicked(target As String)
	
	' you must first get the container from the page -  page.Component("cnt1")
'	Dim cnt As ABMContainer = page.Component("cnt1")
	
	' then get the item attached to the container -  cnt.Component("report")
'	Dim report As ABMCombo = cnt.Component("report")

    Log("img1 clicked")
	Dim img As ABMImage = page.Component("img1")
	img.IsCircular = Not(img.IsCircular)
	img.Rotate(180)
	img.Refresh

	
End Sub

Sub report_Clicked(Target As String)
	
	' you must first get the container from the page -  page.Component("cnt1")
	Dim cnt As ABMContainer = page.Component("cnt1")
	
	' then get the item attached to the container -  cnt.Component("report")
	Dim report As ABMCombo = cnt.Component("report")  ' not used in this example since target has itemID
	Dim lbl As ABMLabel = page.Component("imgname")
	lbl.Text = "Click the Image"
	lbl.Refresh
	
	'  the image belongs to the page - page.Component("img1")
	Dim img As ABMImage = page.Component("img1")
	
	' get the selected item from the combo...  
	' the Target contains the item selected....
	Dim selected As Int = Target ' report.GetActiveItemId

	' now find the person in the table	
	Dim sql As SQL = DBM.GetSQL
	Dim users As List = DBM.SQLSelect(sql, "SELECT * FROM users WHERE UserID = "&selected, Null)
	Dim id As String = ""
	
	If users.Size > 0 Then
		For i = 0 To users.Size -1
			Dim user As Map = users.Get(i)
			' set the image name associated with selected user
			id = user.Get("s1")
		Next
	End If
	DBM.CloseSQL(sql)   ' always close the SQL


	' set the image source for selected person...
   img.Source = "../images/dumb/"&id
   img.SetFixedSize(400,400)
   img.IsCircular = False
   img.Refresh ' IMPORTANT!!!
   
End Sub





Sub Run_Report
	
	Dim cnt As ABMContainer = page.Component("cnt1")
	
	Dim cmbtrk As ABMCombo = cnt.Component("combtrk")
	Dim cmbtrl As ABMCombo = cnt.Component("combtrl")
	Dim repto As ABMCombo = cnt.Component("repto")
	Dim rgdefect As ABMRadioGroup = cnt.Component("rgdefect")

    ' the above container components were never defined...  No Harm...  Silent Error.
	
	page.Msgbox("NONE","use title for big, bold messages","Check The Debug Logs for Errors"&CRLF&"Container Components Not Found","OK",False,ABM.MSGBOX_POS_CENTER_LEFT,"")
	
End Sub

	
' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	page.SaveNavigationBarPosition
	If Action = "ContPage" Then Return

	If Action = "LogOff" Then
		ABMShared.LogOff(page)
		Return
	End If

	ABMShared.NavigateToPage(ws,ABMPageId, Value)
End Sub


Sub btnrun_clicked(target As String)
	
	Run_Report
	
End Sub


Sub BuildSimpleItem(id As String, icon As String, Title As String) As ABMLabel
	Dim lbl As ABMLabel
	If icon <> "" Then
		lbl.Initialize(page, id, Title, ABM.SIZE_H6, True, "header")
	Else
		lbl.Initialize(page, id, Title, ABM.SIZE_H6, True, "")
	End If
	lbl.VerticalAlign = True
	lbl.IconName = icon
	Return lbl
End Sub




public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)
	
	theme.AddCellTheme("cnter")
	theme.Cell("cnter").Align = ABM.CELL_ALIGN_CENTER

	theme.AddCheckboxTheme("cbox")
	theme.Checkbox("cbox").ZDepth = ABM.ZDEPTH_3
	
	theme.AddPaginationTheme("pgn1")
	theme.Pagination("pgn1").NavigationButtonsBackColor = ABM.COLOR_AMBER
	
	' modal sheet
	theme.AddContainerTheme("modalcontent")
	theme.Container("modalcontent").BackColor = ABM.COLOR_WHITE
	
	' modal sheet
	theme.AddContainerTheme("modalfooter")
	theme.Container("modalfooter").BackColor = ABM.COLOR_LIGHTBLUE
	
	' chip
	theme.AddChipTheme("chip")
	theme.Chip("chip").BackColorIntensity = ABM.INTENSITY_LIGHTEN4
	
	' note container theme
	theme.AddContainerTheme("notetheme")
	theme.Container("notetheme").BackColor = ABM.COLOR_BLUEGREY
	theme.Container("notetheme").BackColorIntensity = ABM.INTENSITY_LIGHTEN5
	theme.Container("notetheme").ZDepth = ABM.ZDEPTH_1
		
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)
	theme.AddPDFViewerTheme("pdfth")
	theme.PDFViewer("pdfth").ToolbarColor = ABM.COLOR_AMBER
	theme.AddContainerTheme("cntth")
	theme.Container("cntth").BackColor = ABM.COLOR_AMBER
	theme.Container("cntth").BackColorIntensity = ABM.INTENSITY_LIGHTEN4
	theme.Container("cntth").ZDepth = ABM.ZDEPTH_3
	theme.AddCellTheme("cellc")
	theme.Cell("cellc").Align = ABM.CELL_ALIGN_CENTER
	
	theme.AddButtonTheme("btnl")
	
	theme.AddInputTheme("thminp1")
	theme.Input("thminp1").BackColor = ABM.COLOR_CYAN
	theme.Input("thminp1").BackColorIntensity = ABM.INTENSITY_LIGHTEN3
	
End Sub

